import processing.core.*; 
import processing.xml.*; 

import peasy.*; 
import processing.opengl.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Balloon extends PApplet {


//import net.java.games.jogl.*;


PeasyCam cam;
// GL gl;

float axis_X = 0;
float axis_Y = 0;
float axis_Z = 0;

float control_X = 100;
float control_Y = 100;
float control_Z = 0;

float offset_X = 0;
float offset_Y = 100;
float offset_Z = 0;

int totalSegments = 5;

PVector[] orbit = new PVector[totalSegments];
Segment[] segments = new Segment[totalSegments];


public void setup() {
	size(1200,800,OPENGL); 
	// gl = ((PGraphicsGL)g).gl;
	// gl.glEnable(GL.GL_CULL_FACE);

	cam = new PeasyCam(this, 1000);
	cam.setMinimumDistance(50);
	cam.setMaximumDistance(2000);

	
    // --------------------------------------------------------------------
    // parse data
    // --------------------------------------------------------------------

	for(int i=0;i<totalSegments;i++){
		segments[i] = new Segment();
		segments[i].seed = i+1;
	}

}
public void draw() {
	
	background(0);
	
	drawAxes(400);
	
	// --------------------------------------------------------------------
	// draw base 
	// --------------------------------------------------------------------
	float angleX,angleY;
	int i,j,k;
	float percentage;

	PVector segmentOffset = new PVector(0,0,0);
	// --------------------------------------------------------------------
	// parse data
	// --------------------------------------------------------------------
	
	// all positions are set to absolute;

	// segments[0].parse();
	// segmentOffset.add(segments[0].startAbsoluteVec);

	
	segments[1].endRelativeVec.y = -.5f*(mouseY-height/2);
	segments[1].endRelativeVec.x = -.5f*(mouseX-width/2);
	segments[1].resetRelatives();

	segments[3].endRelativeVec.y = mouseY-height/2;
	segments[3].endRelativeVec.x = mouseX-width/2;
	
	segments[3].resetRelatives();
	
	
	for(i=0;i<totalSegments;i++){
		
		segments[i].createAbsolutes();
		segments[i].updateAbsolutes(segmentOffset);

		segmentOffset.add(segments[i].endRelativeVec.get());
		
		segments[i].parse();
	}

	for(i=0;i<totalSegments;i++){
		segments[i].drawGuides();
	}

	/*
	PVector sumOffset = segments[0].storedOffset.get();
	PVector sumControl = segments[0].storedControl.get();
	PVector sumAxis = segments[0].storedControl.get();

	segments[0].offset.set(sumOffset);
	sumOffset.add(segments[0].armLength.get());
	sumControl.add(segments[0].control.get());
	sumAxis.add(segments[0].storedAxis.get());
	
	segments[0].parse();

	for(i=1;i<totalSegments;i++){
		
		sumControl = segments[i-1].storedControl.get();
		sumControl.add(sumOffset);

		sumAxis = segments[i-1].storedAxis.get();
		sumAxis.add(sumOffset);		
		
		segments[i].offset.set(sumOffset);
		segments[i].control.set(sumControl);
		segments[i].axis.set(sumAxis);
		
		sumControl.add(segments[i].control.get());
		sumOffset.add(segments[i].armLength.get());
		
		segments[i].parse();
	}
		
	
	
	
	
	// --------------------------------------------------------------------
	// draw data
	// --------------------------------------------------------------------
	for(i=0;i<totalSegments;i++){
		segments[i].drawGuides();
		// segments[i].draw();
	}
	*/
}


public void drawAxes(float radius) {
  noFill();
  strokeWeight(1);
  stroke(255, 0, 0,255);
  line(0, 0, 0, radius, 0, 0);
  stroke(0, 255, 0,255);
  line(0, 0, 0, 0, radius, 0);
  stroke(0, 0, 255,255);
  line(0, 0, 0, 0, 0, radius);

  stroke(0xff00FF00,51);
  pushMatrix();
  translate(0, radius,0);
  box(10);
  popMatrix();             

  stroke(0xffFF0000,51);
  pushMatrix();
  translate(radius, 0,0);
  box(10);
  popMatrix(); 

  stroke(0xff0000FF,51);
  pushMatrix();
  translate(0, 0,radius);
  box(10);
  popMatrix(); 

  stroke(0xffFFFFFF,51);
  ellipse(0, 0, 200, 200);

  stroke(0xffFFFFFF,51);
  box(radius*2);
}

public Quaternion quat_mult(Quaternion q1, Quaternion q2) {

  float a = (q1.a*q2.a - q1.b*q2.b - q1.c*q2.c - q1.d*q2.d);
  float b = (q1.a*q2.b + q1.b*q2.a + q1.c*q2.d - q1.d*q2.c);
  float c = (q1.a*q2.c - q1.b*q2.d + q1.c*q2.a + q1.d*q2.b);
  float d = (q1.a*q2.d + q1.b*q2.c - q1.c*q2.b + q1.d*q2.a);
  Quaternion result = new Quaternion(a,b,c,d);
  return result;
}

// Quaternion multiplication without the .a component
public PVector quat_pointmult( Quaternion q1, Quaternion q2) {
  float x = (q1.a*q2.b + q1.b*q2.a + q1.c*q2.d - q1.d*q2.c);
  float y = (q1.a*q2.c - q1.b*q2.d + q1.c*q2.a + q1.d*q2.b);
  float z = (q1.a*q2.d + q1.b*q2.c - q1.c*q2.b + q1.d*q2.a);
  PVector result = new PVector(x,y,z);
  return result;
}


class Quaternion {
  public float a = 0;
  public float b = 0;
  public float c = 0;
  public float d = 1;

  public Quaternion(float aa,float bb,float cc,float dd) {
    this.a = aa;
    this.b = bb;
    this.c = cc;
    this.d = dd;
  }
}
public PVector rotateAroundArbitraryAxis(PVector offsetParam,PVector controlParam,PVector axisParam,float angle) {
	PVector control = controlParam.get();
	PVector axis = axisParam.get();
	PVector offset = offsetParam.get();

	control.sub(offset);
	axis.sub(offset);
	axis.normalize(axis);

	float rads = PI/180 * angle;                       
	float sinTheta = sin(rads*.5f);
	float cosTheta = cos(rads*.5f);

	Quaternion rotQuat   = new Quaternion(  cosTheta,  
	sinTheta * axis.x,  
	sinTheta * axis.y,  
	sinTheta * axis.z );
	Quaternion pointQuat = new Quaternion(  0,
	control.x,
	control.y,
	control.z );
	Quaternion conjQuat  = new Quaternion(  rotQuat.a,
	-rotQuat.b,
	-rotQuat.c,
	-rotQuat.d );

	Quaternion temp = quat_mult(rotQuat,pointQuat);
	PVector result = quat_pointmult(temp,conjQuat);
	result.add(offset);
	return result;
}

public PVector rotateAroundZAxis(PVector offset, PVector controlParam, float angle) {

	PVector control = controlParam.get();
	control.sub(offset);

	float rads = PI/180 * angle;
	float cosTheta = cos(rads);
	float sinTheta = sin(rads);

	float x = cosTheta*control.x + sinTheta*control.y;
	float y = -sinTheta*control.x + cosTheta*control.y;
	float z = control.z;

	PVector result = new PVector(x,y,z);
	result.add(offset);

	return result;
}

public PVector rotateAroundYAxis(PVector offset, PVector controlParam, float angle) {
	PVector control = controlParam.get();
	control.sub(offset);

	float rads = PI/180 * angle;
	float cosTheta = cos(rads);
	float sinTheta = sin(rads);

	float x = cosTheta*control.x - sinTheta*control.z;
	float y = control.y;
	float z = sinTheta*control.x + cosTheta*control.z;

	PVector result = new PVector(x,y,z);

	result.add(offset);

	return result;
}

public PVector rotateAroundXAxis(PVector offset, PVector controlParam, float angle) {
	PVector control = controlParam.get();
	control.sub(offset);

	float rads = PI/180 * angle;
	float cosTheta = cos(rads);
	float sinTheta = sin(rads);

	float x = control.x;
	float y = cosTheta*control.y + sinTheta*control.z;
	float z = -sinTheta*control.y + cosTheta*control.z;

	PVector result = new PVector(x,y,z);

	result.add(offset);

	return result;
}


class Segment {

	public PVector offset;
	public PVector axis;
	public PVector control;
	
	public PVector armLength;

	public PVector storedOffset;
	public PVector storedAxis;
	public PVector storedControl;

	public int seed;

	public float angle;

	public int totalLines = 50;

	public PVector[] orbit = new PVector[totalLines];

	public PVector startRelativeVec;
	public PVector endRelativeVec;
	public PVector startCrossRelativeVec;
	public PVector endCrossRelativeVec;
	public PVector pseudoRelativeVec;

	public PVector startAbsoluteVec;
	public PVector endAbsoluteVec;
	public PVector startCrossAbsoluteVec;
	public PVector endCrossAbsoluteVec;
	public PVector pseudoAbsoluteVec;

		
	int from = color(255, 0, 102);
	int to = color(0, 102, 153);

	public Segment() {
		int radius = 25;

		axis 	= new PVector( 25, 0, 0 );
		offset 	= new PVector( 0,0,0);
		control = new PVector( 0, 10, 0 );

		armLength 	= new PVector( 25, 0, 0 );
		
		storedAxis = new PVector( 0, random(25), random(25) );
		storedOffset = offset.get();
		storedControl = control.get();
		

		createRelatives();
		resetRelatives();
		createAbsolutes();
	}

	public void createRelatives(){
		int radius = 100;
		float half_radius = 100*.5f;
		startRelativeVec = new PVector( 0, 0, 0 );
		endRelativeVec = new PVector( random(radius), random(radius)-half_radius, random(radius)-half_radius );
		pseudoRelativeVec = new PVector( 0, 0, 30 );
		startCrossAbsoluteVec = new PVector( 0, 0, 0 );
		endCrossAbsoluteVec = new PVector( 0, 0, 0 );
	}

	public void resetRelatives(){
		
		startCrossRelativeVec = endRelativeVec.cross(pseudoRelativeVec);
		startCrossRelativeVec.normalize();
		startCrossRelativeVec.mult(30);

		endCrossRelativeVec = startCrossRelativeVec.get();
		endCrossRelativeVec.add(endRelativeVec);

	}
	
	
	public void createAbsolutes(){
		startAbsoluteVec = startRelativeVec.get();
		endAbsoluteVec = endRelativeVec.get();
		startCrossAbsoluteVec = startCrossRelativeVec.get();
		endCrossAbsoluteVec = endCrossRelativeVec.get();
		pseudoAbsoluteVec = pseudoRelativeVec.get();
	}
	
	public void updateAbsolutes(PVector offset){
		startAbsoluteVec.add(offset);
		endAbsoluteVec.add(offset);
		startCrossAbsoluteVec.add(offset);
		endCrossAbsoluteVec.add(offset);
		pseudoAbsoluteVec.add(offset);
	}
	
	public void parse() {
		for(int i=0;i<totalLines;i++) {
			// angle = 360*float(i)/float(totalLines) + frameCount*(totalLines-seed+1)*.125;
			angle = 360*PApplet.parseFloat(i)/PApplet.parseFloat(totalLines) +360*(1-PApplet.parseFloat(seed)/PApplet.parseFloat(totalLines)) + frameCount;
			orbit[i] = rotateAroundArbitraryAxis( offset, control, axis, angle );
		}
	}

	public void draw() {
		drawWidthArray(orbit,0xffFFFFFF);
	}
	
	public void drawGuides() {
		/*
		drawPoint(offset,5,#FF00FF);
		drawPoint(control,3,#00FF00);
		
		drawLine(axis,offset,1,#FFFFFF);
		drawLine(control,offset,1,#FFFF00);
		*/
		
		drawPoint(endAbsoluteVec,3,0xffFFFFFF);
		drawLine(startAbsoluteVec,endAbsoluteVec,1,0xffFFFFFF);

		drawPoint(startCrossAbsoluteVec,3,0xffFF00FF);
		drawLine(startAbsoluteVec,startCrossAbsoluteVec,1,0xffFF00FF);

		drawPoint(endCrossAbsoluteVec,3,0xff00FF00);
		drawLine(endAbsoluteVec,endCrossAbsoluteVec,1,0xff00FF00);

		drawLine(startAbsoluteVec,pseudoAbsoluteVec,1,0xff00FF00);

	}

	public void drawWidthArray(PVector[] orbiter, int colorParam) {

		PVector curr = new PVector(0,0,0);
		PVector prev = new PVector(0,0,0);  
		int lines = orbiter.length;
		float percentage;
		float colorShifter = sin( ((PApplet.parseFloat(seed) / PApplet.parseFloat(totalSegments) + frameCount*.001f) * TWO_PI))*.5f+.5f;
		strokeWeight(1);
		int interColor = lerpColor(from, to,  colorShifter);

		for(int i=1;i<lines;i++) {
			curr = orbiter[i].get();
			prev = orbiter[i-1].get();

			percentage = (PApplet.parseFloat(i)/PApplet.parseFloat(lines)) * 255;

			noStroke();

			fill(interColor, percentage);
			beginShape(TRIANGLE_FAN);
			vertex(prev.x,prev.y,prev.z);
			vertex(curr.x,curr.y,curr.z);
			vertex(offset.x,offset.y,offset.z);
			vertex(prev.x,prev.y,prev.z);
			endShape();

		}
	}

	public void drawPoint(PVector pointParam, int strokeParam, int colorParam) {
		strokeWeight(strokeParam);
		stroke(colorParam,255);
		point( pointParam.x,pointParam.y,pointParam.z);
	}

	public void drawLine(PVector pointAParam,PVector pointBParam, int strokeParam, int colorParam) {
		strokeWeight(strokeParam);
		stroke(colorParam,102);
		line( pointAParam.x,pointAParam.y,pointAParam.z,pointBParam.x,pointBParam.y,pointBParam.z);
	}
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--stop-color=#cccccc", "Balloon" });
  }
}
