import peasy.*;
//import net.java.games.jogl.*;
import processing.opengl.*;

PeasyCam cam;
// GL gl;

float axis_X = 0;
float axis_Y = 0;
float axis_Z = 0;

float control_X = 100;
float control_Y = 100;
float control_Z = 0;

float offset_X = 0;
float offset_Y = 100;
float offset_Z = 0;

int totalSegments = 5;

PVector[] orbit = new PVector[totalSegments];
Segment[] segments = new Segment[totalSegments];


void setup() {
	size(1200,800,OPENGL); 
	// gl = ((PGraphicsGL)g).gl;
	// gl.glEnable(GL.GL_CULL_FACE);

	cam = new PeasyCam(this, 1000);
	cam.setMinimumDistance(50);
	cam.setMaximumDistance(2000);

	
    // --------------------------------------------------------------------
    // parse data
    // --------------------------------------------------------------------

	for(int i=0;i<totalSegments;i++){
		segments[i] = new Segment();
		segments[i].seed = i+1;
	}

}
void draw() {
	
	background(0);
	
	drawAxes(400);
	
	// --------------------------------------------------------------------
	// draw base 
	// --------------------------------------------------------------------
	float angleX,angleY;
	int i,j,k;
	float percentage;

	PVector segmentOffset = new PVector(0,0,0);
	// --------------------------------------------------------------------
	// parse data
	// --------------------------------------------------------------------
	
	// all positions are set to absolute;

	// segments[0].parse();
	// segmentOffset.add(segments[0].startAbsoluteVec);

	
	segments[1].endRelativeVec.y = -.5*(mouseY-height/2);
	segments[1].endRelativeVec.x = -.5*(mouseX-width/2);
	segments[1].resetRelatives();

	segments[3].endRelativeVec.y = mouseY-height/2;
	segments[3].endRelativeVec.x = mouseX-width/2;
	
	segments[3].resetRelatives();
	
	
	for(i=0;i<totalSegments;i++){
		
		segments[i].createAbsolutes();
		segments[i].updateAbsolutes(segmentOffset);

		segmentOffset.add(segments[i].endRelativeVec.get());
		
		segments[i].parse();
	}

	for(i=0;i<totalSegments;i++){
		segments[i].drawGuides();
	}

	/*
	PVector sumOffset = segments[0].storedOffset.get();
	PVector sumControl = segments[0].storedControl.get();
	PVector sumAxis = segments[0].storedControl.get();

	segments[0].offset.set(sumOffset);
	sumOffset.add(segments[0].armLength.get());
	sumControl.add(segments[0].control.get());
	sumAxis.add(segments[0].storedAxis.get());
	
	segments[0].parse();

	for(i=1;i<totalSegments;i++){
		
		sumControl = segments[i-1].storedControl.get();
		sumControl.add(sumOffset);

		sumAxis = segments[i-1].storedAxis.get();
		sumAxis.add(sumOffset);		
		
		segments[i].offset.set(sumOffset);
		segments[i].control.set(sumControl);
		segments[i].axis.set(sumAxis);
		
		sumControl.add(segments[i].control.get());
		sumOffset.add(segments[i].armLength.get());
		
		segments[i].parse();
	}
		
	
	
	
	
	// --------------------------------------------------------------------
	// draw data
	// --------------------------------------------------------------------
	for(i=0;i<totalSegments;i++){
		segments[i].drawGuides();
		// segments[i].draw();
	}
	*/
}


void drawAxes(float radius) {
  noFill();
  strokeWeight(1);
  stroke(255, 0, 0,255);
  line(0, 0, 0, radius, 0, 0);
  stroke(0, 255, 0,255);
  line(0, 0, 0, 0, radius, 0);
  stroke(0, 0, 255,255);
  line(0, 0, 0, 0, 0, radius);

  stroke(#00FF00,51);
  pushMatrix();
  translate(0, radius,0);
  box(10);
  popMatrix();             

  stroke(#FF0000,51);
  pushMatrix();
  translate(radius, 0,0);
  box(10);
  popMatrix(); 

  stroke(#0000FF,51);
  pushMatrix();
  translate(0, 0,radius);
  box(10);
  popMatrix(); 

  stroke(#FFFFFF,51);
  ellipse(0, 0, 200, 200);

  stroke(#FFFFFF,51);
  box(radius*2);
}

